from rasa.nlu.components import Component
from rasa.nlu import utils
from rasa.nlu.model import Metadata
import os
import pandas as pd
import typing
from typing import Any, Optional, Text, Dict
import numpy as np


class Extracteur(Component):
	"""A custom sentiment analysis component"""
	name = "MOIS_EXTRACTION"
	provides = ["entities"]
	requires = ["tokens"]
	defaults = {}
	language_list = ["en"]
	print('initialised the class')

	def __init__(self, component_config=None):
		super(Extractor_new, self).__init__(component_config)

	def train(self, training_data, cfg, **kwargs):
		"""Load the sentiment polarity labels from the text
		   file, retrieve training tokens and after formatting
		   data train the classifier."""



	def convert_to_rasa(self, value):
		"""Convert model output into the Rasa NLU compatible output format."""

		entity = {"value": value,
				  
				  "entity": "TYPE",
				  "extractor": "extractor"}

		return entity
		


	def process(self, message, **kwargs):
		"""Retrieve the tokens of the new message, pass it to the classifier
			and append prediction results to the message class."""
		if not self :
			entities = []
		else:
	
			tokens = [t.text for t in message.get("tokens")]
			datas = pd.read_csv('dict_cdg.csv',sep=';',encoding="windows-1256") 
			entity= np.array(datas['mois'])
			value= np.array(datas['value'])
			ent_val = {}
			for i in range(len(entity)):
				ent_val[entity[i]] = value[i]
			for word in tokens:
				for key in ent_val:
					if list(key) == word:
						entity = ent_val[key]
			entity_conv = self.convert_to_rasa(entity)
			if entity_conv == []:
				message.set("entities",[],add_to_output=True)
			else:

				message.set("entities", [entity_conv], add_to_output=True)